<?php

namespace Ems\Repository;

use Doctrine\ORM\EntityManager;

use Util\QueryUtils;
use Util\Tables;

class FeriasRepository {
    
    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }

    // Olhar nrorg padrão
    public function getPrevisaoFerias(
        string $nrorg,
        string $nrorgpadrao,
        string $dtmescompetenc,
        string $nrtipohierarq,
        string $vinculo         = null,
        string $estrutgeren     = null,
        string $estrutlegal     = null,
        string $meslimite       = null,
        string $omitiragrup     = null,
        string $vincafast       = null
    ) : Array {
        
        try {
            $sql = <<<SQL
                 /*principal*/
                SELECT
                  VM.NRVINCULOM,
                  VM.CDMATRICULA    MATRICULA,
                  VM.NMVINCULOM     NOMEFUNCI,
                  OH.NMOCUPACAOH    OCUPACAO,
                  TO_CHAR(VM.DTADMISSAOVINC, 'DD/MM/YYYY') ADMISSAO,
                  /*TO_CHAR(ADD_MONTHS(FERIAS.DTINIAQUISICAO, 23) - 1, 'DD/MM/YYYY') AS DTLIMITE,*/
                  /* DTLIMITE CONSIDERANDO O TEMPO JA GOZADO */
                  TO_CHAR(ADD_MONTHS(FERIAS.DTINIAQUISICAO, 23) - 1 + (NVL(FERIAS.DIAS_GOZO, 1) - 1), 'DD/MM/YYYY') AS DTLIMITE,
                  EH_LEG.NMRAZSOCESTRUT NOMELEGAL,
                  SFH.NMSITUFUNCH,
                  --EH_LEG.NRESTRUTURAM || EH_GER.NRESTRUTURAM NR_LEGAL_GEREN, /*PARA O AGRUPAMENTO FUNCIONAR*/
                  DECODE(:P_OMITIRAGRUP, 'S', NULL, EH_GER.NMRAZSOCESTRUT) NOMEGEREN,
                  DECODE(:P_OMITIRAGRUP, 'S', NULL, EHA.NMRAZSOCESTRUT   ) NOMEAGRUP,
                  --EMA.NRESTRUTURAM || EH_GER.NRESTRUTURAM NR_GEREN_AGRUP, /*PARA O AGRUPAMENTO FUNCIONAR*/
                  ( SELECT INITCAP(NMTIPOHIERARQORG) || ': ' FROM TIPOHIERARQORG
                    WHERE ( NRORG = VM.NRORG OR NRORG = 0 )
                      AND NRTIPOHIERARQORG = :P_NRTIPOHIERARQ ) NOMEHIERARQ,
                  --FE.DTINIAQUISICAO,
                  
                  FERIAS.NRFERIAS,
                  
                  FERIAS.QTDIASMAXFE,
                  FERIAS.QTDIASMINFE,
                  
                  TO_CHAR(FERIAS.DTINIAQUISICAO, 'DD/MM/YYYY') || ' a ' || TO_CHAR(FERIAS.DTFIMAQUISICAO, 'DD/MM/YYYY') || ' | ' || FERIAS.TIPO PERIODOAQUIS,
                  
                  FERIAS.QTDIAAFASTAMENT,
                  FERIAS.QTFALTASPERIODO,
                  
                  CASE
                    WHEN FERIAS.INIULTGOZO IS NULL THEN NULL
                    ELSE TO_CHAR(FERIAS.INIULTGOZO, 'DD/MM/YYYY') || ' a ' || TO_CHAR(FERIAS.FIMULTGOZO, 'DD/MM/YYYY')
                  END AS ULTGOZOFERIAS,
                  
                  --TO_CHAR(FERIAS.INIULTGOZO, 'DD/MM/YYYY') || ' a ' || TO_CHAR(FERIAS.FIMULTGOZO, 'DD/MM/YYYY') ULTGOZOFERIAS,
                  
                  FERIAS.DIAS_GOZO,
                  FERIAS.DIAS_RESTANTE_GOZO,
                  
                  --CAMPOS PEVISÃO
                  TO_CHAR(FERIAS.DTINIPREVISAO, 'DD/MM/YYYY') DTINIPREVISAO,
                  FERIAS.QTDIASPREVISAO,
                  TO_CHAR(FERIAS.DTFINPREVISAO, 'DD/MM/YYYY') DTFINPREVISAO,
                  FERIAS.QTABONOPREVISAO,
                  
                  TO_CHAR(FERIAS.DTINIPREVISAO2, 'DD/MM/YYYY') DTINIPREVISAO2,
                  FERIAS.QTDIASPREVISAO2,
                  TO_CHAR(FERIAS.DTFINPREVISAO2, 'DD/MM/YYYY') DTFINPREVISAO2,
                  FERIAS.QTABONOPREVISAO2,
                  
                  TO_CHAR(FERIAS.DTINIPREVISAO3, 'DD/MM/YYYY') DTINIPREVISAO3,
                  FERIAS.QTDIASPREVISAO3,
                  TO_CHAR(FERIAS.DTFINPREVISAO3, 'DD/MM/YYYY') DTFINPREVISAO3,
                  FERIAS.QTABONOPREVISAO3
                  
                FROM GPE_VINCULOM VM
                JOIN GPE_VINCULOH VH ON VH.NRORG      = VM.NRORG
                                    AND VH.NRVINCULOM = VM.NRVINCULOM
                                    AND VH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_VINCULOH
                                                              WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                                AND NRORG      = VM.NRORG
                                                                AND NRVINCULOM = VM.NRVINCULOM )
                
                JOIN ( 
                    SELECT
                      FE.NRORG,
                      FE.NRVINCULOM,
                      FE.NRFERIAS,
                      FE.IDCONTROLFERIAS,
                      FE.DTINIAQUISICAO,
                      FE.DTFIMAQUISICAO,
                      FE.DTINIPREVISAO,
                      FE.QTDIASPREVISAO,
                      FE.DTFINPREVISAO,
                      FE.QTABONOPREVISAO,
                      FE.DTINIPREVISAO2,
                      FE.QTDIASPREVISAO2,
                      FE.DTFINPREVISAO2,
                      FE.QTABONOPREVISAO2,
                      FE.DTINIPREVISAO3,
                      FE.QTDIASPREVISAO3,
                      FE.DTFINPREVISAO3,
                      FE.QTABONOPREVISAO3,
                      T.NRTIPOFERIAS,
                      T.QTDIASMAXFE,
                      T.QTDIASMINFE,
                      NVL(FE.QTDIAAFASTAMENT,0) QTDIAAFASTAMENT,
                      NVL(FE.QTFALTASPERIODO,0) QTFALTASPERIODO,
                      DECODE(FE.IDCONTROLFERIAS, 'GOZADO_PARCIAL', 'Goz. Parc.',
                                                 'GOZADO_INTEGRAL', 'Goz. Inte.',
                                                 'ADQUIRIDO',      'Adquirido',
                                                 'ABERTO',         'Aberto',
                                                 FE.IDCONTROLFERIAS) TIPO,
                      GZ.DTINIGOZOFERIAS INIULTGOZO,
                      GZ.DTFIMGOZOFERIAS FIMULTGOZO,
                      1 + (GZ.DTFIMGOZOFERIAS) - (GZ.DTINIGOZOFERIAS) DIAS_GOZO,
                      NVL(FE.QTDIASMAXFE, T.QTDIASMAXFE)
                        - NVL( SUM(1 + (GZ.DTFIMGOZOFERIAS) - (GZ.DTINIGOZOFERIAS)) OVER (PARTITION BY FE.NRVINCULOM, FE.DTINIAQUISICAO), 0 )
                        - NVL(GZ.QTDIASABONOFERI, 0) DIAS_RESTANTE_GOZO
                    FROM FPA_FERIAS FE
                    --Último gozo de férias (se houver)
                    LEFT JOIN FPA_GOZOFERIAS GZ ON GZ.NRORG    = FE.NRORG
                                               AND GZ.NRFERIAS = FE.NRFERIAS
                    JOIN FPA_TIPOFERIASH T ON (T.NRORG = 0 OR T.NRORG = FE.NRORG) 
                                          AND T.NRTIPOFERIAS = FE.NRTIPOFERIAS
                    --
                    WHERE 
                      --FE.NRORG      = :P_NRORG
                      --AND FE.NRVINCULOM = :P_VINCULO
                      FE.IDCONTROLFERIAS IN ( 'GOZADO_PARCIAL', 'ADQUIRIDO', 'ABERTO'/*, 'GOZADO_INTEGRAL'*/ )
                      
                      AND FE.DTINIAQUISICAO = (
                        SELECT MIN(DTINIAQUISICAO)
                           FROM FPA_FERIAS
                           WHERE NRORG = FE.NRORG
                             AND NRVINCULOM = FE.NRVINCULOM
                             AND IDCONTROLFERIAS IN ( 'GOZADO_PARCIAL', /*'GOZADO_INTEGRAL',*/ 'ADQUIRIDO', 'ABERTO' )
                      )
                      AND ( TRUNC(ADD_MONTHS(FE.DTINIAQUISICAO, 23), 'MONTH') <= :P_MESLIMITE OR :P_MESLIMITE IS NULL )
                    --GROUP BY FE.NRVINCULOM, FE.NRFERIAS, FE.DTINIAQUISICAO, FE.DTFIMAQUISICAO, FE.DTINIAQUISICAO, FE.IDCONTROLFERIAS, FE.QTDIASMAXFE, T.QTDIASMAXFE, GZ.QTDIASABONOFERI, FE.NRTIPOFERIAS, FE.NRORG
                    ORDER BY FE.NRVINCULOM, FE.DTINIAQUISICAO
                ) FERIAS ON FERIAS.NRORG = VM.NRORG AND FERIAS.NRVINCULOM = VM.NRVINCULOM
                
                LEFT JOIN FPA_TIPOFERIASH TF ON (TF.NRORG = FERIAS.NRORG OR TF.NRORG = :P_NRORG_PADRAO) AND TF.NRTIPOFERIAS = FERIAS.NRTIPOFERIAS
                
                /*Dias Afastado*/
                /*Cargo----------------------------------------------------------------------*/
                LEFT JOIN GPE_OCUPACAOH OH ON OH.NRORG       = VM.NRORG
                                          AND OH.NROCUPACAOM = NVL(VH.NRCARGO, VH.NRFUNCAO)
                                          AND OH.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM GPE_OCUPACAOH
                                                                    WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                                      AND NRORG       = VM.NRORG
                                                                      AND NROCUPACAOM = NVL(VH.NRCARGO, VH.NRFUNCAO) )
                /*Estrutura Gerencial--------------------------------------------------------*/
                LEFT JOIN ESTRUTURAM EM_GER ON EM_GER.NRORG        = VH.NRORG
                                      AND EM_GER.NRESTRUTURAM = VH.NRESTRUTGEREN
                LEFT JOIN ESTRUTURAH EH_GER ON EH_GER.NRORG        = VH.NRORG
                                      AND EH_GER.NRESTRUTURAM = EM_GER.NRESTRUTURAM
                                      AND EH_GER.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                                    WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                                      AND NRORG        = VM.NRORG
                                                                      AND NRESTRUTURAM = EH_GER.NRESTRUTURAM )
                /*Estrutura Legal-----------------------------------------------------------*/
                LEFT JOIN ESTRUTURAM EM_LEG ON EM_LEG.NRORG        = VH.NRORG
                                      AND EM_LEG.NRESTRUTURAM = VH.NRESTRUTLEGAL
                LEFT JOIN ESTRUTURAH EH_LEG ON EH_LEG.NRORG        = VH.NRORG
                                      AND EH_LEG.NRESTRUTURAM = EM_LEG.NRESTRUTURAM
                                      AND EH_LEG.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                                    WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                                      AND NRORG        = VM.NRORG
                                                                      AND NRESTRUTURAM = EM_LEG.NRESTRUTURAM )
                /*ESTRUTURA AGRUPADA*/
                LEFT JOIN ESTRUTURAM EMA ON EMA.NRORG        = VM.NRORG
                                        AND EMA.NRESTRUTURAM = ( SELECT H.NRESTRUTURAMSUP FROM HIERARQUIAORG H
                                                                 WHERE H.NRORG            = VM.NRORG
                                                                   AND H.NRESTRUTURAMREL  = VH.NRESTRUTGEREN
                                                                   AND H.NRTIPOHIERARQORG = :P_NRTIPOHIERARQ
                                                                   AND H.DTINIVIGENCIA = ( SELECT MAX(DTINIVIGENCIA) FROM HIERARQUIAORG
                                                                                           WHERE DTINIVIGENCIA <= LAST_DAY(:P_COMPETENCIA) 
                                                                                             AND NRORG            = VM.NRORG
                                                                                             AND NRESTRUTURAMREL  = VH.NRESTRUTGEREN
                                                                                             AND NRTIPOHIERARQORG = H.NRTIPOHIERARQORG ) )
                LEFT JOIN ESTRUTURAH EHA ON EHA.NRORG        = VM.NRORG
                                        AND EHA.NRESTRUTURAM = EMA.NRESTRUTURAM
                                        AND EHA.DTMESCOMPETENC = ( SELECT MAX(DTMESCOMPETENC) FROM ESTRUTURAH
                                                                   WHERE DTMESCOMPETENC <= :P_COMPETENCIA
                                                                     AND NRORG        = VH.NRORG
                                                                     AND NRESTRUTURAM = EMA.NRESTRUTURAM )
                /*SituaÃ§Ã£o Funcional*/
                LEFT JOIN GPE_ALTESITUFUNC ALTF ON ALTF.NRORG      = VM.NRORG
                                               AND ALTF.NRVINCULOM = VM.NRVINCULOM
                                               AND ALTF.DTINISITUFUNC = ( SELECT MAX(DTINISITUFUNC) FROM GPE_ALTESITUFUNC
                                                                          WHERE DTINISITUFUNC <= LAST_DAY(:P_COMPETENCIA)
                                                                            AND NRORG      = ALTF.NRORG
                                                                            AND NRVINCULOM = ALTF.NRVINCULOM )
                LEFT JOIN GPE_SITUFUNCH SFH ON ( SFH.NRORG IS NULL OR SFH.NRORG = 0 OR SFH.NRORG = VM.NRORG )
                                           AND SFH.NRSITUFUNCM = ALTF.NRSITUFUNCM /*VH.NRSITUFUNCM*/
                                           AND SFH.DTEFETIVA = ( SELECT MAX(DTEFETIVA) FROM GPE_SITUFUNCH
                                                                 WHERE DTEFETIVA <= :P_COMPETENCIA
                                                                   AND ( SFH.NRORG IS NULL OR SFH.NRORG = 0 OR SFH.NRORG = VM.NRORG )
                                                                   AND NRSITUFUNCM = SFH.NRSITUFUNCM )
                /*---------------------------------------------------------------------------*/
                WHERE VM.NRORG = :P_NRORG
                  AND ( VM.DTRESCISAOVINC > LAST_DAY(:P_COMPETENCIA) OR VM.DTRESCISAOVINC IS NULL ) /*VÍNCULOS NÃO DEMITIDOS, RESPEITANDO A COMPETÃŠNCIA*/
                  AND ( VM.NRVINCULOM = :P_VINCULO OR :P_VINCULO IS NULL )
                  AND ( VH.NRESTRUTGEREN = :P_ESTRUTGEREN OR :P_ESTRUTGEREN IS NULL )
                  AND ( VH.NRESTRUTLEGAL = :P_ESTRUTLEGAL OR :P_ESTRUTLEGAL IS NULL )
                  AND ( TRUNC(ADD_MONTHS(FERIAS.DTINIAQUISICAO, 23) - 1, 'MONTH') <= :P_MESLIMITE OR :P_MESLIMITE IS NULL )
                  AND (SFH.IDAFASTSITUFUNC = 'N' OR :P_VINCAFAST = 'S')
                  /*INSERÇÃO DA QUERY DA CONFIDÊNCIALIDADE*/
                  --AND :REPORT_CONDITION
                ORDER BY FERIAS.DTINIAQUISICAO, VM.NMVINCULOM
SQL;

            $query = $this->connection->prepare($sql);

            $query->execute(
                array(
                    'P_OMITIRAGRUP'     => $omitiragrup,
                    'P_NRTIPOHIERARQ'   => $nrtipohierarq,
                    'P_COMPETENCIA'     => $dtmescompetenc,
                    'P_NRORG'           => $nrorg,
                    'P_VINCULO'         => $vinculo,
                    'P_ESTRUTGEREN'     => $estrutgeren,
                    'P_ESTRUTLEGAL'     => $estrutlegal,
                    'P_MESLIMITE'       => $meslimite,
                    'P_VINCAFAST'       => $vincafast,
                    'P_NRORG_PADRAO'    => $nrorgpadrao
                )
            );

            $progFerias = $query->fetchAll();

            return $progFerias;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    /**
     * Rotina destinada a salvar as programações de férias. As informações de previsão são incluídas no registro de férias cujo número de identificação é passado por parâmetro
     * W
     */
    public function setProgramacaoFerias(
        string $nrorg,
        string $nrferias,
        string $nrvinculom,
        string $dtiniprevisao       = null,
        string $dtfinprevisao       = null,
        string $qtdiasprevisao      = null,
        string $qtabonoprevisao     = null,
        string $dtiniprevisao2      = null,
        string $dtfinprevisao2      = null,
        string $qtdiasprevisao2     = null,
        string $qtabonoprevisao2    = null,
        string $dtiniprevisao3      = null,
        string $dtfinprevisao3      = null,
        string $qtdiasprevisao3     = null,
        string $qtabonoprevisao3    = null
    ) : bool {
        
        try {
            $sqlWhereClause = 'NRFERIAS = :P_NRFERIAS AND NRVINCULOM = :P_NRVINCULOM AND NRORG = :P_NRORG';
            
            $columnsToUpdate = array(
                'DTINIPREVISAO'     => $dtiniprevisao,
                'DTFINPREVISAO'     => $dtfinprevisao,
                'QTDIASPREVISAO'    => $qtdiasprevisao,
                'QTABONOPREVISAO'   => $qtabonoprevisao,
                'DTINIPREVISAO2'    => $dtiniprevisao2,
                'DTFINPREVISAO2'    => $dtfinprevisao2,
                'QTDIASPREVISAO2'   => $qtdiasprevisao2,
                'QTABONOPREVISAO2'  => $qtabonoprevisao2,
                'DTINIPREVISAO3'    => $dtiniprevisao3,
                'DTFINPREVISAO3'    => $dtfinprevisao3,
                'QTDIASPREVISAO3'   => $qtdiasprevisao3,
                'QTABONOPREVISAO3'  => $qtabonoprevisao3,
            );
            
            $sql = QueryUtils::buildUpdateStament(Tables::FPA_FERIAS, $columnsToUpdate, $sqlWhereClause);

            $query = $this->connection->prepare($sql);

            $result = $query->execute(
                array(
                    'P_NRFERIAS'    => $nrferias,
                    'P_NRVINCULOM'  => $nrvinculom,
                    'P_NRORG'       => $nrorg
                )
            );

            return $result;
        } catch (\Exception $e) {
            throw $e;
        }
    }
    
    // Parametrizar nrorg padrao (a função get tb)
    // getNrOrgPadrao
    public function getTpFeriasByNrferias($nrorg, $nrorgpadrao, $nrferias) {
        try {
            $sql = <<<SQL
                SELECT
                    NVL(FE.QTDIASMAXFE, TF.QTDIASMAXFE)
                        - NVL( SUM(1 + (ULTGF.DTFIMGOZOFERIAS) - (ULTGF.DTINIGOZOFERIAS)) OVER (PARTITION BY FE.NRVINCULOM, FE.DTINIAQUISICAO), 0 )
                        - NVL(ULTGF.QTDIASABONOFERI, 0) DIAS_RESTANTE_GOZO,
                    TF.QTDIASMINFE,
                    TF.QTDIASMAXFE,
                    TF.NRTIPOFERIASH,
                    TF.NRTIPOFERIAS,
                    TF.DTMESCOMPETENC,
                    TF.NMTIPOFERIASH,
                    TF.IDPERAQUISITIVO,
                    TF.QTPERAQUISITIVO,
                    TF.QTMESAFASTPERDA,
                    TF.IDESTENDEPERAQU,
                    TF.QTDIASMAXABON,
                    TF.VRPERADICFERIAS
                FROM FPA_FERIAS FE
                LEFT JOIN FPA_TIPOFERIASH TF ON (TF.NRORG = FE.NRORG OR TF.NRORG = :P_NRORG_PADRAO) AND TF.NRTIPOFERIAS = FE.NRTIPOFERIAS
                /*Dias Gozo Últimas Férias - Ultimo gozo de ferias - confirmar informacao*/
                LEFT JOIN FPA_GOZOFERIAS ULTGF ON ULTGF.NRORG = FE.NRORG AND ULTGF.NRFERIAS = FE.NRFERIAS AND ULTGF.DTINIGOZOFERIAS = (
                    SELECT MAX(ULTGFF.DTINIGOZOFERIAS)
                      FROM FPA_GOZOFERIAS ULTGFF
                     WHERE ULTGFF.NRORG = ULTGF.NRORG
                           AND ULTGFF.NRFERIAS = ULTGF.NRFERIAS
                )
                WHERE FE.NRORG = :P_NRORG
                      AND FE.NRFERIAS = :P_NRFERIAS
SQL;

            $query = $this->connection->prepare($sql);

            $query->execute(
                array(
                    'P_NRFERIAS'        => $nrferias,
                    'P_NRORG'           => $nrorg,
                    'P_NRORG_PADRAO'    => $nrorgpadrao
                )
            );

            $progFerias = $query->fetch();

            return $progFerias;
        } catch (\Exception $e) {
            throw $e;
        }       
    }
    
    public function getFerias(
        array $params
    ) {
        $sql = <<<SQL
            SELECT
                TO_CHAR(F.DTINIPREVISAO, 'DD/MM/YYYY') DTINIPREVISAO,
                F.*
            FROM
                FPA_FERIAS F
            WHERE
                NRORG = :P_NRORG AND
                NRFERIAS = :P_NRFERIAS
SQL;

        $std = $this->connection->prepare($sql);
        $std->execute($params);

        $ferias = $std->fetch();

        return $ferias;
    }
}